<script setup lang="ts">
import { onBeforeMount, onMounted, ref, watch } from 'vue'
import { useRoute } from 'vue-router'
import { useStore } from 'vuex'
import { AnsiUp } from 'ansi_up' // Import para procesar los Logs
import pipelineMixin from '@/components/gitlab/pipeline/common/pipelineMixin' // Importa el mixin
import ConsoleLogViewer from '@/components/gitlab/pipeline/common/ConsoleLogViewer.vue'
import GitApi from '@/api/gitApi'

interface Job {
  id: number
  name: string
  status: string
  duration: number // Duración en segundos, por ejemplo
  executions: Array<{ id: number; [key: string]: any }> // Lista de ejecuciones, cada una con un id y otros posibles datos
}

interface User {
  username: string
  rol: string
}

// Props
const props = defineProps<{
  job: Job
  filterLevel: string
  searchQuery: string
  hideSearchSwitch: boolean
  searchButton: number
  showAllConsoles: boolean
}>()

// Refs
const ansi = ref<AnsiUp>(new AnsiUp())
const user = ref<User>({ username: '', rol: '' })
const groupId = ref<number>(0)
const projectId = ref<number>(0)
const pipelineId = ref<number>(0)
const jobId = ref<number>(0)
const logFileData = ref<string[]>([])
const processedValues = ref<string[]>([])
const IsConsoleVisible = ref<boolean>(true)
const refreshKey = ref<number>(0)

// Store y route
const store = useStore()
const route = useRoute()

// Watches
watch(
  () => props.searchButton,
  () => {
    console.log('searchButton Pressed')
    refreshKey.value += 1
  },
)

watch(
  () => props.showAllConsoles,
  nuevoValor => {
    console.log('showAllConsoles ..... ', nuevoValor)
    IsConsoleVisible.value = nuevoValor
  },
)

// Lifecycle hooks
onBeforeMount(() => {
  ansi.value = new AnsiUp()

  user.value = store.state.user
  console.log('[LogsConsoleComponent] store is:', store)
  console.log('[LogsConsoleComponent] route is:', route)
  groupId.value = route.params.id as number
  projectId.value = route.params.projectId as number
  pipelineId.value = route.params.pipelineId as number
  jobId.value = props.job.id
})

onMounted(() => {
  // getJobLog();    TODO COMENTED BY ALE
})

// Métodos del mixin
const {
  getProject,
  formatDuration,
  timeAgo,
  jobLink,
  allowToDownloadArtifacts,
  cancelAutoUpdate,
} = pipelineMixin.methods

// Métodos del componente
const hiddenLines = (log: string): boolean => {
  if (props.hideSearchSwitch)
    return true

  const colorFilter = props.filterLevel.toLowerCase()
  const searchFilter = props.searchQuery.toLowerCase()
  const logLower = log.toLowerCase()

  if (colorFilter === 'all' && searchFilter === '')
    return true

  const filterLevelBool = colorFilter !== 'all' && logLower.includes(colorFilter)
  const searchQueryBool = searchFilter !== '' && logLower.includes(searchFilter)

  return filterLevelBool || searchQueryBool
}

const highLight = (log: string): string => {
  const colorFilter = props.filterLevel.toLowerCase()
  const searchFilter = props.searchQuery.toLowerCase()
  let highlightedLog = log

  if (colorFilter !== 'all') {
    highlightedLog = highlightedLog.replace(
      new RegExp(colorFilter, 'gi'),
      match => `<span style="font-size: 14px; background-color: gold; font-weight: bold; color: black;">${match}</span>`,
    )
  }

  if (searchFilter !== '') {
    highlightedLog = highlightedLog.replace(
      new RegExp(searchFilter, 'gi'),
      match => `<span style="font-size: 14px; background-color: gold; font-weight: bold; color: black;">${match}</span>`,
    )
  }

  return highlightedLog
}

const getJobLog = async (): Promise<void> => {
  console.log('getJobLog . jobId=', jobId.value)
  console.log('getJobLog . jobId=', projectId.value)

  const git = new GitApi()
  try {
    const response = await git.getLog(projectId.value, jobId.value)

    logFileData.value = response.data
    await processLogs()
  }
  catch (error) {
    console.error('Console error:', error)
  }
}

const processLogs = async (): Promise<string[]> => {
  console.log('processLogs - executionId=', jobId.value)
  if (!logFileData.value)
    return []

  const logData = applyANSIFormatting(logFileData.value)
  const data = ansi.value.ansi_to_html(logData).split(/\n/gm)

  processedValues.value = data.map(value =>
    value.replace(/^section_(end|start):[0-9,:,\w]+/gm, '').replace('\r', ''),
  )
  console.log(processedValues.value)

  return processedValues.value
}

const applyANSIFormatting = (logComplete: string): string => {
  const whiteColor = '\u001B[37m'
  const endColor = '\u001B[0m'

  const processedLines = logComplete
    .split(/\n/gm)
    .map(originalLine => {
      const lineWithoutOK = originalLine.replace(/\u001B\[0K/g, '')
      const cleanLine = lineWithoutOK.replace(/[\r\n]+/g, '')
      const lineWithoutSections = cleanLine.replace(/^section_(end|start):[0-9,:\w]+/gm, '')

      const matchesStartColor = lineWithoutSections.match(/^\u001B\[(\d+;*\d*)m(?!0)/)
      const matchesEndColor = lineWithoutSections.match(/\u001B\[0;*m$/)

      if (matchesStartColor && matchesEndColor) {
        console.log('matchesStartColor && matchesEndColor')

        return cleanLine
      }
      else if (matchesStartColor && !matchesEndColor) {
        console.log('matchesStartColor && !matchesEndColor')

        const ANSIcode1 = matchesStartColor[1]
        const startColor = `\u001B[${ANSIcode1}m`

        return `${startColor}${cleanLine}${endColor}`
      }
      else if (!matchesStartColor && matchesEndColor) {
        console.log('!matchesStartColor && matchesEndColor')

        return `${whiteColor}${cleanLine}`
      }

      console.log('INCONSISTENT STATE')

      return `${whiteColor}${cleanLine}${endColor}`
    })
    .filter(line => line.trim().length !== 0)

  return processedLines.join('\n')
}

const chipColor = (status: string): string => {
  switch (status) {
    case 'success':
      return 'success' // Verde
    case 'failed':
      return 'error' // Rojo
    case 'running':
      return 'primary' // Azul
    case 'pending':
      return 'warning' // Amarillo
    case 'canceled':
      return 'grey-400' // Gris
    case 'skipped':
      return 'grey-300' // Gris claro
    case 'manual':
      return 'purple' // Púrpura
    case 'created':
      return 'info' // Azul claro
    case 'preparing':
      return 'amber' // Ámbar
    case 'scheduled':
      return 'cyan' // Cian
    case 'waiting_for_resource':
      return 'yellow' // Amarillo
    case 'failed_with_warnings':
      return 'amber' // Ámbar
    default:
      return 'info' // Color predeterminado (Azul claro)
  }
}
</script>

<template>
  <div>
    <VCard
      :key="job.id"
      outlined
      class="card-logs mb-0"
    >
      <!-- CARD HEADER -->
      <VCardTitle
        class="p-0 text-center"
        role="tab"
      >
        <VRow
          no-gutters
          class="w-100"
        >
          <!-- LIST GROUP ITEM 1: Checkbox for Console Toggle -->
          <VCol
            cols="1"
            class="text-left mt-5px"
          >
            <VSwitch
              v-model="IsConsoleVisible"
              inset
              color="primary"
              class="ma-0"
              :value="true"
            >
              <template #thumb>
                <VIcon
                  v-if="IsConsoleVisible"
                  icon="tabler-chevrons-up"
                />
                <VIcon
                  v-else
                  icon="tabler-chevrons-down"
                />
              </template>
            </VSwitch>
          </VCol>

          <!-- LIST GROUP ITEM 2: Job Name -->
          <VCol
            v-if="job.name"
            cols="6"
            class="text-left"
          >
            <h5 class="m-0">
              <strong>Job Name: </strong>{{ job.name }}
            </h5>
          </VCol>

          <!-- LIST GROUP ITEM 3: Job Status -->
          <VCol cols="2">
            <VChip
              :color="chipColor(job.status)"
              size="small"
              variant="outlined"
            >
              <small class="text-muted">{{ job.status }}</small>
            </VChip>
          </VCol>

          <!-- LIST GROUP ITEM 4: Duration -->
          <VCol cols="2">
            <small class="text-muted">
              Duration: {{ formatDuration(job.duration) }}
            </small>
          </VCol>

          <!-- LIST GROUP ITEM 5: Attempts -->
          <VCol
            v-if="job.executions && job.executions.length > 0"
            cols="1"
          >
            <small
              class="text-muted"
              :title="`Execution: ${job.executions[0].id}`"
            >
              Attempts: {{ job.executions.length }}
            </small>
          </VCol>
        </VRow>
      </VCardTitle>
      <!-- END CARD HEADER -->

      <!-- CARD BODY -->
      <!--
        v-card-text v-show="IsConsoleVisible && processedValues.length > 0" class="m-0 p-0">
        <div class="console py-1" :key="refreshKey">
        <div class="log-line" v-for="(log, index) in processedValues" :key="index">
        <div v-if="hiddenLines(log)">
        <div class="d-inline mr-4 ml-4 index" v-html="index + 1"></div>
        <div class="d-inline overflow-x-auto my-0 console" v-html="highLight(log)"/>
        </div>
        </div>
        </div>
        </v-card-text
      -->
      <ConsoleLogViewer
        :job-id="jobId"
        :project-id="projectId"
        :is-visible="IsConsoleVisible"
        :filter-level="filterLevel"
        :search-query="searchQuery"
      />
      <!-- END CARD BODY -->
    </VCard>
  </div>
</template>

<style scoped>
.console {
  font-family: monospace;
  text-align: left;
  background-color: #111;
  color: #fff;
  white-space: pre-wrap;
  font-size: 11px; /* Ajusta este valor según tus necesidades */
  line-height: 1.2; /* Ajusta el interlineado aquí */
}
.mt-5px {
  margin-top: 5px;
}
.index {
  color: #6e6b7b;
  min-width: 4% !important;
  text-align: right;
}

.card-logs {
  box-shadow: 0 4px 24px 0 rgba(34, 41, 47, .1);
  border: 1px solid rgba(34, 41, 47, .125);
  background-color: transparent;
}

/* Estilo para los encabezados dentro de card-logs */
.card-logs .card-headers {
  background-color: #f8f9fa; /* Ejemplo de color de fondo */
  padding: 10px; /* Ejemplo de relleno */
  border-bottom: 1px solid #e0e0e0; /* Ejemplo de borde inferior */
  /* border-bottom: none; */
  /* padding: 1.5rem; */
  /* background-color: transparent; */
}

/* This is to avoid the hover of the list items inside the card header of the Console */
.card-logs .disable-list-item:hover,
.card-logs .disable-list-item:focus,
.card-logs .disable-list-item:active {
  background-color: transparent !important;
  pointer-events: none;
}
</style>
